// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/* Generated by Together */

package de.uka.ilkd.key.casetool.together.scripts.menuextension;

import de.uka.ilkd.key.casetool.ReprModelClass;
import de.uka.ilkd.key.ocl.OCLExport;
import java.io.*;

import javax.swing.*;

import com.togethersoft.openapi.ide.project.*;

public class ClassMenuPoint5 extends ClassMenu {

    static File lastDirectory=null;
    
    private File directory;

    public String getMenuEntry(){
	return "Export OCL spec of class";
    }

    protected String runCore(ReprModelClass aReprModelClass){
	
	if (lastDirectory==null) {
	    String tprFile = IdeProjectManagerAccess
		.getProjectManager().getActiveProject().getFileName();
	    String projectRoot = tprFile.substring
		(0, tprFile.lastIndexOf(File.separator));
	    directory=new File(projectRoot);
	}
	else  
	    directory=lastDirectory;
	JFileChooser jFC = new JFileChooser(directory);
	int saved = jFC.showSaveDialog(new JFrame());
	if (saved == JFileChooser.APPROVE_OPTION) {
	    String filename = jFC.getSelectedFile().getName();    
	    filename = jFC.getCurrentDirectory()+File.separator+
		(filename.endsWith(".ocl") ? filename : 
		filename+".ocl");

	    try{
		File file = new File(filename);
		FileWriter output = new FileWriter(file);
		OCLExport oclExporter = 
		    new OCLExport(aReprModelClass, output);
		oclExporter.export();
		output.close();
		lastDirectory = jFC.getCurrentDirectory();
	    } catch (IOException ioe) {
		String errorMsg = "Could not save \n"+filename+".\n";
		errorMsg += ioe.toString();	    
		JOptionPane.showMessageDialog(new JFrame(), errorMsg, "Oops...", 
					      JOptionPane.ERROR_MESSAGE);
	    }

	}	

        return "";
    }
}
