// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//

/** wraps an array of ProgramElements to achieve immutability */
package de.uka.ilkd.key.java;

public class ProgramElementArray implements java.io.Serializable {

    private ProgramElement[] arr;


    /** creates a new ProgramElementArray
     * @param arr the ProgrammElement array to wrap
     */
    public ProgramElementArray(ProgramElement[] arr) {
	this.arr=arr;
    }

    /** gets the element at the specified position
     * @param pos an int describing the position
     */
    public ProgramElement get(int pos) {
	return arr[pos];
    }

    /** gets the element at the specified position
     * @param pos an int describing the position
     */
    public ProgramElement getProgramElement(int pos) {
	return arr[pos];
    }

    /** gets the element at the specified position
     * @param pos an int describing the position
     */
    public Expression getExpression(int pos) {
	return (Expression)arr[pos];
    }

    /** @return size of the array */
    public int size() {
	return arr.length;
    }


}
