// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//


package de.uka.ilkd.key.java.annotation;

import de.uka.ilkd.key.logic.ArrayOfTerm;
import de.uka.ilkd.key.java.*;
import de.uka.ilkd.key.java.visitor.Visitor;

public abstract class TermContainerAnnotation implements Annotation{

    /**
     * returns an array of the terms contained in this annotation. 
     */
    public abstract ArrayOfTerm getArrayOfTerm();

    /**
     * returns the number of terms contained in this annotation.
     */
    public abstract int getTermCount();

    /**
     * Creates a copy of tca using the terms in aot.
     */
    public abstract TermContainerAnnotation create(TermContainerAnnotation tca,
						   ArrayOfTerm aot);

    public SourceElement getFirstElement(){
	return null;
    }

    public SourceElement getLastElement(){
      	return null;
    }

    public Position getStartPosition(){
	return null;
    }

    public Position getEndPosition(){
     	return null;
    }

    public Position getRelativePosition(){
    	return null;
    }
    
    public PositionInfo getPositionInfo(){
	return null;
    }

    public void visit(Visitor v){
	// do nothing
    }

    public void prettyPrint(PrettyPrinter w) throws java.io.IOException{
	// do nothing
    }

    public boolean equalsModRenaming(SourceElement se, 
				     NameAbstractionTable nat){
	return false;
    }

}
