// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
//
//
//

package de.uka.ilkd.key.logic.sort;

import de.uka.ilkd.key.logic.Name;

public class ClassInstanceSortImpl extends AbstractNonCollectionSort 
    implements ObjectSort{


    SetOfSort ext;

    /** creates a ClassInstanceSort*/
    public ClassInstanceSortImpl(Name name, SetOfSort ext) {
	super(name);
	this.ext = ext;
    }

    /** creates a ClassInstanceSort*/
    public ClassInstanceSortImpl(Name name, de.uka.ilkd.key.logic.sort.Sort ext) {
	this(name, SetAsListOfSort.EMPTY_SET.add(ext));
    }


    /** creates a ClassInstanceSort*/
    public ClassInstanceSortImpl(Name name) {
	this(name, SetAsListOfSort.EMPTY_SET);
    }

   
    /**
     * @return the sorts of the predecessors of this sort
     */
    public SetOfSort extendsSorts() {
        return ext;
    }

}
