// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
// This file is part of KeY - Integrated Deductive Software Design 
// Copyright (C) 2001-2003 Universitaet Karlsruhe, Germany
//                         and Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//

package de.uka.ilkd.key.proof.init;

import java.io.*;
import de.uka.ilkd.key.java.*;
import de.uka.ilkd.key.util.ProgressMonitor;


/**
 * sub-class of JavaInputWithJMLSpecBrowser which is used to parse just a
 * single JML-enriched java source file.
 */
public class KeYJMLInput extends JavaInputWithJMLSpecBrowser {

    public KeYJMLInput(String name, File file, ProgressMonitor monitor){
	super(name, file, monitor);
    }

    public String getJavaPath() throws ProofInputException {
	return path.getParentFile().getAbsolutePath();
    }
    
    public String readJava() throws ProofInputException{
	Recoder2KeY r2k = new Recoder2KeY(initConfig.getServices(),
					  initConfig.namespaces());
	try { 
	    parseJMLSpecs(getTypesWithJMLSpecs(
			      r2k.readCompilationUnitsAsFiles(
				  new String[]{path.getPath()})));
	    //	    initConfig.getServices().getImplementation2SpecMap().setProgVarNS(
	    //		initConfig.progVarNS());
	} catch (ConvertException ce) {
	    throw new ProofInputException(ce);
	} 
	return null;
    }	

}
