// This file is part of KeY - Integrated Deductive Software Design
// Copyright (C) 2001-2005 Universitaet Karlsruhe, Germany
//                         Universitaet Koblenz-Landau, Germany
//                         Chalmers University of Technology, Sweden
//
// The KeY system is protected by the GNU General Public License. 
// See LICENSE.TXT for details.
//
/*
 * Created on 18.12.2004
 */
package de.uka.ilkd.key.util;

import java.io.File;

import de.uka.ilkd.key.logic.Term;
import de.uka.ilkd.key.proof.Proof;
import de.uka.ilkd.key.proof.ProofAggregate;
import de.uka.ilkd.key.proof.init.KeYUserProblemFile;
import de.uka.ilkd.key.proof.init.ProblemInitializer;
import de.uka.ilkd.key.proof.init.ProofInputException;

/**
 * @author bubel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class HelperClassForTests {

    
    public ProofAggregate parse(File file) {
        ProblemInitializer pi = null;
        ProofAggregate result = null;
        try {	    
            if (pi == null) {
                pi = ProblemInitializer.problemInitializerForTests
                (new KeYUserProblemFile("UpdatetermTest", file, null, false), 
		 true);                
                result = pi.setUpTest();                             
            } else {
                result = pi.setUpProof(new KeYUserProblemFile("UpdatetermTest", 
                        file, null, false));               
            }                                  
        } catch (Exception e) {
            System.err.println("Exception occured while parsing "+file+"\n");
            e.printStackTrace();
            System.exit(-1);
        }
        return result;
    }
    
    public ProofAggregate parseThrowException(File file) throws ProofInputException{
        ProblemInitializer pi = null;
        pi = ProblemInitializer.problemInitializerForTests
            (new KeYUserProblemFile("UpdatetermTest", file, null, false), 
	     true);
        return pi.setUpTest();        
    }
       
    public Term extractProblemTerm(Proof p) {
        return p.root().sequent().succedent().iterator().next().formula();
    }

}
