package paycard;

public class LogFile {
    

    /*@ public invariant logArray.length == logFileSize && 
      @     currentRecord < logFileSize && 
      @     currentRecord >= 0 && \nonnullelements(logArray);
      @*/

    private /*@ spec_public @*/ static int logFileSize = 3;
    private /*@ spec_public @*/ int currentRecord;
    private /*@ spec_public @*/ LogRecord[] logArray = new LogRecord[logFileSize];

    public /*@pure@*/ LogFile() {
	int i=0;
	while(i<logArray.length){
            logArray[i++] = new LogRecord();
	}
        currentRecord = 0;
    }


    /*@ public normal_behavior
      @    requires balance >= 0;
      @    assignable currentRecord, logArray[*].transactionId, 
      @               logArray[*].balance, logArray[*].empty, 
      @               LogRecord.transactionCounter;
      @    ensures \old(currentRecord) + 1 != logFileSize ? 
      @        currentRecord == \old(currentRecord) + 1 : currentRecord == 0;
      @    ensures logArray[currentRecord].balance == balance;
      @*/
    public void addRecord(int balance) throws CardException {
	currentRecord++;
	if (currentRecord == logFileSize) currentRecord = 0;
        logArray[currentRecord].setRecord(balance);
    }


    /*@ public normal_behavior
      @    ensures (\forall int i; 0 <= i && i<logArray.length;
      @             logArray[i].balance <= \result.balance);
      @ */
    public /*@pure@*/ LogRecord getMaximumRecord(){
	LogRecord max = logArray[0];
	int i=1;    
	/*@ loop_invariant 0<=i && i <= logArray.length 
          @                && max!=null &&
	  @   (\forall int j; 0 <= j && j<i; 
	  @    max.balance >= logArray[j].balance);
	  @ assignable max, i;
	  @ decreases logArray.length - i; 
	  @*/
	while(i<logArray.length){
	    LogRecord lr = logArray[i++];
	    if (lr.getBalance() > max.getBalance()){
		max = lr;
	    }        
	}
	return max;
    }

    public int[] a;


    /*@ public normal_behavior
      @ requires a!=null && a.length > 0;
      @ ensures (\exists int index;  0 <= index && index<\old(a.length); 
      @                  \old(a[0])==a[index] && \old(a[index])==a[0] &&
      @                  (\forall int i; 0 <= i && i<\old(a.length); 
      @                           a[0] >= a[i] && (i!=0 && i!=index ==> a[i]==\old(a[i]) )));
      @ diverges true;                          
      @ */
    void demo() {
      int counter = 0;
      int idx = 0;
      int l=a.length;
	/*@ loop_invariant  0<=counter && counter<=a.length &&
          @ 0<=idx && idx<a.length  &&
          @ (\forall int x; x>=0 && x<counter; a[idx]>=a[x]);
	  @ assignable idx, counter;
	  @ decreases l-counter;
	  @*/
      while (counter<l) {
        if (a[counter] > a[idx])
	  idx=counter;
          counter=counter+1;
      }
      int tmp=a[idx];
      a[idx]=a[0];
      a[0]=tmp;
    }

}
