#!/bin/sh

LISTFILE=grammars2list.txt
GFOPTIONS=gfOptions.txt
GFCOMMAND=gf

cd $1
./checkGF.sh 2> /dev/null

if [ -e gf_found ]
then
    echo [GF grammars are being compiled]
    echo $PWD
    cat $GFOPTIONS | $GFCOMMAND -batch
    echo "writing grammars2list.txt"
    if [ -f $LISTFILE ]
	then
	rm $LISTFILE
    fi
    touch $LISTFILE
    for x in `ls -rtR1A`
      do 
	# new directories in the ls output start with a "."
	# These serve as headlines.
	# On darwin "./" gets no such headline, on Linux it does.
      if [ ${x:0:1} = "." ]
	  then
	  DIR=${x:0:`expr ${#x} - 1`}/
      elif [[ "$DIR" != "./" && -n "$DIR" ]]
	  then
	  echo ${DIR}$x >> $LISTFILE
      fi
    done
    
    for x in `ls -rt1A`
      do 
      if [[ $x != "compileGrammars.sh" && "$x" != $LISTFILE && -f "$x" && "$x" != "$GFOPTIONS" ]]
	  then
	  echo $x >> $LISTFILE
      fi
    done
else
    echo [gf not found, skipping compiling the grammars]
fi

